from . import get_info, search_info


def get(category, _id):
    """ Get infomation of album/artist/org/event/product
    """
    support = {
        'album':    get_info.album,
        'artist':   get_info.artist,
        'org':      get_info.org,
        'event':    get_info.event,
        'product':  get_info.product,
    }
    if not category or category not in support.keys():
        raise ValueError("Unsupport query type " + category)

    if not _id.isdigit() or not isinstance(_id, int):
        raise ValueError('Query id must be a number.')

    return support[category](_id)


def search(category, _id, strict=False):
    """ Search infomation of album/artist/org/event/product
    """
    support = {
        'album':    search_info.album,
        'artist':   search_info.artist,
        'org':      search_info.org,
        'event':    search_info.event,
        'product':  search_info.product,
    }
    if not category:
        return search_info.all(_id)

    if category not in support.keys():
        if strict:
            raise ValueError(
                "Strict mode is on. Unsupport query type " + category
            )
        return search_info.all(_id)

    if not _id.isdigit() or not isinstance(_id, int):
        raise ValueError('Query id must be a number.')

    return support[category](_id)
